  MEMBER

  MAP
  END

  INCLUDE('ABINIMGR.INC'),ONCE


mvINIClass.Init     PROCEDURE(STRING S)
  CODE
  SELF.GotAppFrame = False
  PARENT.INIT(S)


mvINIClass.Fetch    PROCEDURE(STRING ProcedureName,WINDOW W)
cWinW               SHORT,AUTO
cWinH               SHORT,AUTO
cWinWt              SHORT,AUTO
cWinHt              SHORT,AUTO
AppFrameW           SHORT,AUTO
AppFrameH           SHORT,AUTO
  CODE
  IF W{PROP:Type} = CREATE:application
    SELF.GotAppFrame  = True
    SELF.AppFrameRef &= W
  END
  cWinW = W{PROP:Width}                             !Remember 'Design'-width
  cWinH = W{PROP:Height}                            !Remember 'Design'-height

  PARENT.Fetch(ProcedureName, W)

  IF NOT W{PROP:Iconize}
    IF W{PROP:Width} < cWinW                        !INI-value smaller than Design-value
      W{PROP:Width} = cWinW                         ! restore Design-value
    END
    IF W{PROP:Height} < cWinH                       !INI-value smaller than Design-value
      W{PROP:Height} = cWinH                        ! restore Design-value
    END
    !
    IF SELF.GotAppFrame AND W{PROP:Type} <> CREATE:application
      AppFrameW  = SELF.AppFrameRef{PROP:Width}
      AppFrameH  = SELF.AppFrameRef{PROP:Height}
      AppFrameH -= 10                               !Caption
      AppFrameH -= 10                               !Menu
      AppFrameH -= 20                               !Toolbar
      cWinW      = W{PROP:Width}                    !Client Window width
      cWinH      = W{PROP:Height}                   !Client Window height
      cWinWt     = (cWinW / 10)                     !ten percent of width
      cWinHt     = (cWinH / 10)                     !ten percent of height
      IF W{PROP:XPos} > (AppFrameW - cWinWt)        !less than 10% visable
        W{PROP:XPos} = (AppFrameW - cWinW) - 5      ! Place at the right border
        IF W{PROP:XPos} < 0                         ! Client Window larger than AppFrame
          W{PROP:XPos} = 1
        END
      END
      IF (W{PROP:XPos} + cWinW) < cWinWt            !less than 10% visable
        W{PROP:XPos} = 1
      END
      IF W{PROP:YPos} > (AppFrameH - cWinHt)        !less than 10% visable
        W{PROP:YPos} = (AppFrameH - cWinH) - 1      ! Place at the bottom
        IF W{PROP:YPos} < 0                         ! Client Window larger than AppFrame
          W{PROP:YPos} = 1
        END
      END
      IF (W{PROP:YPos} + cWinH) < cWinHt            !less than 10% visable
        W{PROP:YPos} = 1
      END
    END
  END


